# -*- encoding=utf8 -*-
__author__ = "liguangyu"

import random

"""
case_tag:cmdc_api,cmdc删除_批量_套包正价,2264,2264-60,sit,bs
主数据平台:后台运营系统套包列表查询、套包正价导入、删除接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
from common.db.db import mySql
import os
import requests
import json

module = "cmdc_special_fresenius_group"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)
# 文件上传专用请求头
headers1 = commonFuc().get_business_data(module, "json_headers2", cmdc_access_token)

# 第二步套包正价列表获取
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url2")
request_body = commonFuc().get_business_data(module, "payload2")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取套包正价信息
group_code = result["data"]["list"][0]["groupCode"]
group_name = result["data"]["list"][0]["groupName"]

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/按条件删除正价套包.xlsx"

# 将商品信息写入文件中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=group_code)
excel.write_data(row=2, column=2, value=group_name)

# 第三步进行文件导入
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url23")

request_body = commonFuc().get_business_data(module, "payload23")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}

# 发送请求
result = requests.post(url, files=files, headers=headers1, data=request_body)
result = json.loads(result.content)

# 获取freseniusPriceIds用于后续删除操作
fresenius_price_id = result["data"]["freseniusAgreementPrices"][0]["freseniusPriceId"]

# 第四步进行套包正价确认删除
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url24")
request_body = {"freseniusPriceIds": [fresenius_price_id], "groupPriceStatus": 0, "remarks": "套包正价删除操作验证"}

"""
 场景: 删除_批量_套包正价验证
 用例名称：删除_批量_套包正价
 输出：{"groupPriceStatus": 0}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
print(result)
# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 数据库查询已删除套包正价对应的状态
sql = "SELECT t.groupPriceStatus FROM `cmdc-order`.tc_fresenius_agreement_price t WHERE freseniusPriceId = {};".format(
    fresenius_price_id)
result = {"groupPriceStatus": mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]}
print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict23")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
file.close()
